package com.bergerkiller.bukkit.nolagg;

import java.util.List;

import net.minecraft.server.Packet;
import net.minecraft.server.Packet51MapChunk;
import net.minecraft.server.Packet53BlockChange;

import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.craftbukkit.entity.CraftPlayer;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.LeavesDecayEvent;


public class NLBlockListener extends BlockListener {
		
	public void onLeavesDecay(LeavesDecayEvent event) {
		if (event.isCancelled()) return;
		fixColumn(event.getBlock(), 2);
	}
	public void onBlockBreak(BlockBreakEvent event) {
		if (event.isCancelled()) return;
		fixColumn(event.getBlock());
	}
	public void onBlockPlace(BlockPlaceEvent event) {
		if (event.isCancelled()) return;
		fixColumn(event.getBlock());
	}
	
	public boolean isTransparent(Material type) {
		return isTransparent(type.getId());
	}
	public boolean isTransparent(int typeid) {
		return !net.minecraft.server.Block.o[typeid];
	}
	public boolean isSemiTransparent(Material mat) {
		switch (mat) {
		case ICE : return true;
		case LEAVES : return true;
		default: return false;
		}
	}
	
	public void fixColumn(Block start) {
		fixColumn(start, 1);
	}
	public void fixColumn(Block start, int delay) {
		fixColumn(start, start.getType(), delay);
	}
	public void fixColumn(final Block start, final Material type, int delay) {
		NoLagg.plugin.getServer().getScheduler().scheduleSyncDelayedTask(NoLagg.plugin, new Runnable() {
			public void run() {
				fixColumn(start, type);
			}
		}, delay);
	}
	public void fixColumn(final Block start, final Material type) {
		final List<Player> players = start.getWorld().getPlayers();
		if (players.isEmpty()) return;
		fixColumn(players, start, type);
	}
	public void fixColumn(final List<Player> players, Block start, Material type) {
		while (true) {
			while (isSemiTransparent(type)) {
				start = start.getRelative(BlockFace.DOWN);
				if (start.getY() < 2) return;
				type = start.getType();
			}
			//air?
			int height = 0;
			while (isTransparent(type) || isSemiTransparent(type)) {
				start = start.getRelative(BlockFace.DOWN);
				if (start.getY() < 2) break;
				type = start.getType();
				height++;
			}
			if (height == 0) return;
			//send packet for this stack of blocks
			Packet packet;
			if (height == 1) {
				packet = new Packet53BlockChange(start.getX(), start.getY() + 1, start.getZ(), ChunkHandler.getNative(start.getWorld()));
			} else {
				packet = new Packet51MapChunk(start.getX(), start.getY() + 1, start.getZ(), 1, height, 1, ChunkHandler.getNative(start.getWorld()));
			}
			for (Player player : players) {
				if (Util.isPlayerNearBlock(player, start.getX(), start.getZ())) {
					//prepare packet
					((CraftPlayer) player).getHandle().netServerHandler.sendPacket(packet);
				}
			}
		}
	}
				
}
